/*******************************************************************************
 * FoxDataStore_MenuItems generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDataStore_MenuItems extends UIDataStore_GameResource
    transient
    native
    config(Game)
    hidecategories(Object,UIRoot);

struct native IgnoredPlayer
{
    var UniqueNetId UniqueId;
    var init string PlayerName;

    structdefaultproperties
    {
        UniqueId=(Uid=none)
        PlayerName=""
    }
};

struct native BannedPlayer
{
    var float BannedTimeStamp;
    var float TimeBanned;
    var UniqueNetId BannedID;

    structdefaultproperties
    {
        BannedTimeStamp=0.0
        TimeBanned=0.0
        BannedID=(Uid=none)
    }
};

struct native PlayedMapInfo
{
    var string MapName;
    var int LastUsed;

    structdefaultproperties
    {
        MapName=""
        LastUsed=0
    }
};

var FoxSavedMigrationInfo HostMigrationInfo;
var array<UniqueNetId> MutedNetIDs;
var array<IgnoredPlayer> IgnoreList;
var array<BannedPlayer> BannedPlayers;
var string SavedPartyChat;
var string SavedGlobalChat;
var string SavedClanChat;
var string SavedWhisperChat;
var string SavedHelpChat;
var int SavedCollapsableChatStaus;
var string LastPlayedMapName;
var array<PlayedMapInfo> PlayedMaps;
var string ReturnToMenuCommandGroup;
var string OverrideLoadoutID;
var array<UIResourceDataProvider> GameModeProviders;
var array<string> GameModeNames;
var array<UIResourceDataProvider> MapProviders;
var array<UIResourceDataProvider> KeyBindingProviders;
var array<UIResourceDataProvider> ControlProviders;
var array<UIResourceDataProvider> ControllerBindingProviders;

event Registered(LocalPlayer PlayerOwner)
{
    super(UIDataStore).Registered(PlayerOwner);
    GetAllResourceDataProviders(class'FoxDataProvider_GameModeInfo', GameModeProviders);
    GetAllResourceDataProviders(class'FoxDataProvider_MapInfo', MapProviders);
    GetAllResourceDataProviders(class'FoxDataProvider_KeyBindings', KeyBindingProviders);
    GetAllResourceDataProviders(class'FoxDataProvider_Controls', ControlProviders);
    GetAllResourceDataProviders(class'FoxDataProvider_ControllerBindings', ControllerBindingProviders);
    GetAllGameModeAbbreviatedNames(GameModeNames);
    //return;    
}

event Unregistered(LocalPlayer PlayerOwner)
{
    GameModeProviders.Length = 0;
    MapProviders.Length = 0;
    KeyBindingProviders.Length = 0;
    ControlProviders.Length = 0;
    ControllerBindingProviders.Length = 0;
    GameModeNames.Length = 0;
    //return;    
}

// Export UFoxDataStore_MenuItems::execGetAllResourceDataProviders(FFrame&, void* const)
protected native function GetAllResourceDataProviders(class<UIResourceDataProvider> ProviderClass, out array<UIResourceDataProvider> Providers);

function FoxDataProvider_GameModeInfo GetGameModeInfo(int GameModeIndex)
{
    // End:0x1A
    if(GameModeIndex >= GameModeProviders.Length)
    {
        return none;
    }
    return FoxDataProvider_GameModeInfo(GameModeProviders[GameModeIndex]);
    //return ReturnValue;    
}

function string GetGameModeAbbreviatedName(int Index)
{
    // End:0x40
    if((Index >= 0) && Index < GameModeNames.Length)
    {
        return GameModeNames[Index];
    }
    // End:0x43
    else
    {
        return "";
    }
    //return ReturnValue;    
}

function GetAllGameModeAbbreviatedNames(out array<string> AbbrNames)
{
    local FoxDataProvider_GameModeInfo GameModeProvider;
    local class<FoxGame> GameClass;
    local int I;
    local string GameModeName;

    AbbrNames.Length = GameModeProviders.Length;
    I = 0;
    J0x20:
    // End:0x120 [Loop If]
    if(I < GameModeProviders.Length)
    {
        GameModeName = "";
        GameModeProvider = FoxDataProvider_GameModeInfo(GameModeProviders[I]);
        // End:0xF5
        if(GameModeProvider != none)
        {
            GameClass = class<FoxGame>(DynamicLoadObject(GameModeProvider.GameMode, class'Class'));
            // End:0xF5
            if(GameClass != none)
            {
                GameModeName = GameClass.default.GameTypeAbbreviatedName;
            }
        }
        AbbrNames[I] = GameModeName;
        ++ I;
        // [Loop Continue]
        goto J0x20;
    }
    //return;    
}

function int GetGameModeProviderIndexByGameClass(class<FoxGame> GameClass)
{
    local array<FoxDataProvider_GameModeInfo> Providers;
    local int I;
    local string GameClassMarkup;

    GameClassMarkup = "FoxGame." $ string(GameClass.Name);
    GetAllGameModeProviders(Providers);
    I = 0;
    J0x54:
    // End:0xBA [Loop If]
    if(I < Providers.Length)
    {
        // End:0xAC
        if(Providers[I].GameMode ~= GameClassMarkup)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x54;
    }
    return -1;
    //return ReturnValue;    
}

function class<FoxGame> GetGameClassFromGameProvider(FoxDataProvider_GameModeInfo GameProvider)
{
    return class<FoxGame>(DynamicLoadObject(GameProvider.GameMode, class'Class'));
    //return ReturnValue;    
}

function class<FoxGame> GetGameClassFromProviderIndex(int ProviderIndex)
{
    return GetGameClassFromGameProvider(FoxDataProvider_GameModeInfo(GameModeProviders[ProviderIndex]));
    //return ReturnValue;    
}

function FoxDataProvider_GameModeInfo GetGameModeProviderByGameClass(class<FoxGame> GameClass)
{
    local array<FoxDataProvider_GameModeInfo> Providers;
    local int I;
    local string GameClassMarkup;

    GameClassMarkup = "FoxGame." $ string(GameClass.Name);
    GetAllGameModeProviders(Providers);
    I = 0;
    J0x54:
    // End:0xC4 [Loop If]
    if(I < Providers.Length)
    {
        // End:0xB6
        if(Providers[I].GameMode ~= GameClassMarkup)
        {
            return Providers[I];
        }
        ++ I;
        // [Loop Continue]
        goto J0x54;
    }
    return none;
    //return ReturnValue;    
}

function FoxDataProvider_GameModeInfo GetGameModeProviderByName(name ProviderName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xC5 [Loop If]
    if(I < GameModeProviders.Length)
    {
        // End:0xB7
        if((GameModeProviders[I].Name == ProviderName) || FoxDataProvider_GameModeInfo(GameModeProviders[I]).AbbreviatedName == ProviderName)
        {
            return FoxDataProvider_GameModeInfo(GameModeProviders[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0xD0:
    // End:0xF6 [Loop If]
    if(I < GameModeProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0xD0;
    }
    return none;
    //return ReturnValue;    
}

function int GetGameModeProviderIndexByName(name ProviderName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xB2 [Loop If]
    if(I < GameModeProviders.Length)
    {
        // End:0xA4
        if((GameModeProviders[I].Name == ProviderName) || FoxDataProvider_GameModeInfo(GameModeProviders[I]).AbbreviatedName == ProviderName)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0xBD:
    // End:0xE3 [Loop If]
    if(I < GameModeProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0xBD;
    }
    return -1;
    //return ReturnValue;    
}

function GetAllGameModeProviders(out array<FoxDataProvider_GameModeInfo> Providers)
{
    local int I;

    Providers.Length = 0;
    I = 0;
    J0x17:
    // End:0x66 [Loop If]
    if(I < GameModeProviders.Length)
    {
        Providers.AddItem(FoxDataProvider_GameModeInfo(GameModeProviders[I]));
        ++ I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

event int GetMapIndex(string MapName)
{
    local int I, MapIndex;
    local FoxDataProvider_MapInfo MapInfoProvider;

    I = 0;
    J0x0B:
    // End:0x98 [Loop If]
    if(I < MapProviders.Length)
    {
        MapInfoProvider = FoxDataProvider_MapInfo(MapProviders[I]);
        // End:0x7F
        if(MapInfoProvider.MapName ~= MapName)
        {
            return MapIndex;
        }
        ++ MapIndex;
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return -1;
    //return ReturnValue;    
}

function int GetMapIndexByProviderName(name MapProviderName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x71 [Loop If]
    if(I < MapProviders.Length)
    {
        // End:0x63
        if(MapProviders[I].Name == MapProviderName)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return -1;
    //return ReturnValue;    
}

event string GetMapNameByIndex(int Index)
{
    local FoxDataProvider_MapInfo MapProvider;

    // End:0x7D
    if((Index >= 0) && Index < MapProviders.Length)
    {
        MapProvider = FoxDataProvider_MapInfo(MapProviders[Index]);
        // End:0x7D
        if(MapProvider != none)
        {
            return MapProvider.FriendlyName;
        }
    }
    return "";
    //return ReturnValue;    
}

event FoxDataProvider_MapInfo GetMapDataProviderAtIndex(int Index)
{
    local int I, MapIndex;
    local FoxDataProvider_MapInfo MapInfoProvider;

    I = 0;
    J0x0B:
    // End:0x83 [Loop If]
    if(I < MapProviders.Length)
    {
        MapInfoProvider = FoxDataProvider_MapInfo(MapProviders[I]);
        // End:0x6A
        if(MapIndex == Index)
        {
            return MapInfoProvider;
        }
        ++ MapIndex;
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return none;
    //return ReturnValue;    
}

event FoxDataProvider_MapInfo GetMapInfoByMapName(const string MapName)
{
    local int I;
    local FoxDataProvider_MapInfo MapInfoProvider;

    I = 0;
    J0x0B:
    // End:0x8D [Loop If]
    if(I < MapProviders.Length)
    {
        MapInfoProvider = FoxDataProvider_MapInfo(MapProviders[I]);
        // End:0x7F
        if(MapInfoProvider.MapName ~= MapName)
        {
            return MapInfoProvider;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return none;
    //return ReturnValue;    
}

event FoxDataProvider_MapInfo GetMapInfoByMapProviderName(const name ProviderName)
{
    local int I;
    local FoxDataProvider_MapInfo MapInfoProvider;

    I = 0;
    J0x0B:
    // End:0x8D [Loop If]
    if(I < MapProviders.Length)
    {
        MapInfoProvider = FoxDataProvider_MapInfo(MapProviders[I]);
        // End:0x7F
        if(MapInfoProvider.Name == ProviderName)
        {
            return MapInfoProvider;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return none;
    //return ReturnValue;    
}

event array<FoxDataProvider_MapInfo> GetValidMapsForGameType(class<FoxGame> GameClass)
{
    return GetValidMapsForGameTypeString("FoxGame." $ string(GameClass));
    //return ReturnValue;    
}

function array<FoxDataProvider_MapInfo> GetValidMapsForGameTypeString(string GameClassString)
{
    local int I;
    local array<FoxDataProvider_MapInfo> MapInfoProviders;
    local FoxDataProvider_GameModeInfo GameModeInfoProvider;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < MapProviders.Length)
    {
        MapInfoProviders.AddItem(FoxDataProvider_MapInfo(MapProviders[I]));
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0x65:
    // End:0xF3 [Loop If]
    if(I < GameModeProviders.Length)
    {
        // End:0xE5
        if(FoxDataProvider_GameModeInfo(GameModeProviders[I]).GameMode ~= GameClassString)
        {
            GameModeInfoProvider = FoxDataProvider_GameModeInfo(GameModeProviders[I]);
            // [Explicit Break]
            goto J0xF3;
        }
        ++ I;
        J0xF3:
        // [Loop Continue]
        goto J0x65;
    }
    // End:0x10C
    if(GameModeInfoProvider == none)
    {
        return MapInfoProviders;
    }
    I = MapInfoProviders.Length - 1;
    J0x123:
    // End:0x1E2 [Loop If]
    if(I >= 0)
    {
        // End:0x164
        if(MapInfoProviders[I].SupportedGameModes.Length == 0)
        {
        }
        // End:0x1D4
        else
        {
            // End:0x1D4
            if(MapInfoProviders[I].SupportedGameModes.Find(GameModeInfoProvider.AbbreviatedName) < 0)
            {
                MapInfoProviders.RemoveItem(MapInfoProviders[I]);
            }
        }
        -- I;
        // [Loop Continue]
        goto J0x123;
    }
    return MapInfoProviders;
    //return ReturnValue;    
}

event array<name> GetAllStreamLevelNames(class<FoxGame> GameClass, int MapIndex)
{
    local array<name> StreamLevelNames, GameTypeSpecificStreamNames;
    local int I;

    StreamLevelNames = GetBaseLevelStreamNames(MapIndex);
    GameTypeSpecificStreamNames = GetGameTypeLevelStreamNames(GameClass, MapIndex);
    I = 0;
    J0x4E:
    // End:0x94 [Loop If]
    if(I < GameTypeSpecificStreamNames.Length)
    {
        StreamLevelNames.AddItem(GameTypeSpecificStreamNames[I]);
        ++ I;
        // [Loop Continue]
        goto J0x4E;
    }
    return StreamLevelNames;
    //return ReturnValue;    
}

event array<name> GetBaseLevelStreamNames(int MapIndex)
{
    local FoxDataProvider_MapInfo MapInfo;
    local array<name> StreamLevelNames;

    StreamLevelNames.Length = 0;
    MapInfo = GetMapDataProviderAtIndex(MapIndex);
    // End:0xB7
    if(MapInfo != none)
    {
        StreamLevelNames = MapInfo.BaseLevelStreamNames;
        // End:0xB7
        if(MapInfo.RainStreamName != 'None')
        {
            StreamLevelNames.AddItem(MapInfo.RainStreamName);
        }
    }
    return StreamLevelNames;
    //return ReturnValue;    
}

event name GetRainLevelStreamNameByMapIndex(int MapIndex)
{
    local FoxDataProvider_MapInfo MapInfo;

    MapInfo = GetMapDataProviderAtIndex(MapIndex);
    return ((MapInfo != none) ? MapInfo.RainStreamName : 'None');
    //return ReturnValue;    
}

event name GetRainLevelStreamNameByMapName(string MapName)
{
    local FoxDataProvider_MapInfo MapInfo;

    MapInfo = GetMapInfoByMapName(MapName);
    return ((MapInfo != none) ? MapInfo.RainStreamName : 'None');
    //return ReturnValue;    
}

event array<name> GetGameTypeLevelStreamNames(class<FoxGame> GameClass, int MapIndex)
{
    local FoxDataProvider_MapInfo MapInfo;
    local array<name> StreamLevelNames;

    StreamLevelNames.Length = 0;
    MapInfo = GetMapDataProviderAtIndex(MapIndex);
    // End:0x2D2
    if(MapInfo != none)
    {
        // End:0x7A
        if(GameClass == class'FoxGameMP_DM')
        {
            StreamLevelNames = MapInfo.DMStreamNames;
        }
        // End:0x2D2
        else
        {
            // End:0x107
            if((((GameClass == class'FoxGameMP_TDM') || GameClass == class'FoxGameMP_CTDM') || GameClass == class'FoxGameMP_KC') || GameClass == class'FoxGameMP_LTS')
            {
                StreamLevelNames = MapInfo.TDMStreamNames;
            }
            // End:0x2D2
            else
            {
                // End:0x149
                if(GameClass == class'FoxGameMP_CP')
                {
                    StreamLevelNames = MapInfo.DomStreamNames;
                }
                // End:0x2D2
                else
                {
                    // End:0x18B
                    if(GameClass == class'FoxGameMP_TKOTH')
                    {
                        StreamLevelNames = MapInfo.KOTHStreamNames;
                    }
                    // End:0x2D2
                    else
                    {
                        // End:0x1CD
                        if(GameClass == class'FoxGameMP_CTF')
                        {
                            StreamLevelNames = MapInfo.CTFStreamNames;
                        }
                        // End:0x2D2
                        else
                        {
                            // End:0x20F
                            if(GameClass == class'FoxGameMP_EOTS')
                            {
                                StreamLevelNames = MapInfo.EOTSStreamNames;
                            }
                            // End:0x2D2
                            else
                            {
                                // End:0x251
                                if(GameClass == class'FoxGameMP_PL')
                                {
                                    StreamLevelNames = MapInfo.PLStreamNames;
                                }
                                // End:0x2D2
                                else
                                {
                                    // End:0x293
                                    if(GameClass == class'FoxGameMP_SND')
                                    {
                                        StreamLevelNames = MapInfo.SNDStreamNames;
                                    }
                                    // End:0x2D2
                                    else
                                    {
                                        // End:0x2D2
                                        if(GameClass == class'FoxGameMP_LMS')
                                        {
                                            StreamLevelNames = MapInfo.LMSStreamNames;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return StreamLevelNames;
    //return ReturnValue;    
}

function AddMutedPlayerID(UniqueNetId UniqueId)
{
    local int I;
    local UniqueNetId ZeroId;

    // End:0x20
    if(UniqueId == ZeroId)
    {
        return;
    }
    I = 0;
    J0x2B:
    // End:0x7B [Loop If]
    if(I < MutedNetIDs.Length)
    {
        // End:0x6D
        if(MutedNetIDs[I] == UniqueId)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x2B;
    }
    MutedNetIDs.AddItem(UniqueId);
    //return;    
}

function RemoveMutedPlayerID(UniqueNetId UniqueId)
{
    local UniqueNetId ZeroId;

    // End:0x20
    if(UniqueId == ZeroId)
    {
        return;
    }
    MutedNetIDs.RemoveItem(UniqueId);
    //return;    
}

function bool WasPlayerMuted(UniqueNetId UniqueId)
{
    local int I;
    local UniqueNetId ZeroId;

    // End:0x2A
    if(UniqueId == ZeroId)
    {
        ScriptTrace();
        return false;
    }
    I = 0;
    J0x35:
    // End:0x85 [Loop If]
    if(I < MutedNetIDs.Length)
    {
        // End:0x77
        if(MutedNetIDs[I] == UniqueId)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x35;
    }
    return false;
    //return ReturnValue;    
}

event AddIgnoredPlayerByID(UniqueNetId UniqueId)
{
    local IgnoredPlayer NewIgnoredPlayerInfo;
    local UniqueNetId ZeroId;

    // End:0x20
    if(UniqueId == ZeroId)
    {
        return;
    }
    NewIgnoredPlayerInfo.UniqueId = UniqueId;
    NewIgnoredPlayerInfo.PlayerName = "";
    AddIgnoredPlayerInfo(NewIgnoredPlayerInfo);
    //return;    
}

event AddIgnoredPlayerByName(string PlayerName)
{
    local IgnoredPlayer NewIgnoredPlayerInfo;

    // End:0x12
    if(PlayerName == "")
    {
        return;
    }
    NewIgnoredPlayerInfo.PlayerName = PlayerName;
    AddIgnoredPlayerInfo(NewIgnoredPlayerInfo);
    //return;    
}

event AddIgnoredPlayer(UniqueNetId UniqueId, string PlayerName)
{
    local IgnoredPlayer NewIgnoredPlayerInfo;

    NewIgnoredPlayerInfo.UniqueId = UniqueId;
    NewIgnoredPlayerInfo.PlayerName = PlayerName;
    AddIgnoredPlayerInfo(NewIgnoredPlayerInfo);
    //return;    
}

event AddIgnoredPlayerInfo(IgnoredPlayer NewIgnoredPlayerInfo)
{
    local int I;
    local UniqueNetId ZeroId;

    I = 0;
    J0x0B:
    // End:0x1BE [Loop If]
    if(I < IgnoreList.Length)
    {
        // End:0x1B0
        if((IgnoreList[I].UniqueId != ZeroId && IgnoreList[I].UniqueId == NewIgnoredPlayerInfo.UniqueId) || IgnoreList[I].PlayerName == NewIgnoredPlayerInfo.PlayerName)
        {
            // End:0x16B
            if(NewIgnoredPlayerInfo.UniqueId != ZeroId)
            {
                IgnoreList[I].UniqueId = NewIgnoredPlayerInfo.UniqueId;
            }
            IgnoreList[I].PlayerName = NewIgnoredPlayerInfo.PlayerName;
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    IgnoreList.AddItem(NewIgnoredPlayerInfo);
    //return;    
}

function RemoveIgnoredPlayerByID(UniqueNetId UniqueId)
{
    local UniqueNetId ZeroId;
    local int I;

    // End:0x20
    if(UniqueId == ZeroId)
    {
        return;
    }
    I = 0;
    J0x2B:
    // End:0xA3 [Loop If]
    if(I < IgnoreList.Length)
    {
        // End:0x95
        if(IgnoreList[I].UniqueId == UniqueId)
        {
            IgnoreList.Remove(I, 1);
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x2B;
    }
    //return;    
}

function RemoveIgnoredPlayerByName(string PlayerName)
{
    local int I;

    // End:0x12
    if(PlayerName == "")
    {
        return;
    }
    I = 0;
    J0x1D:
    // End:0x92 [Loop If]
    if(I < IgnoreList.Length)
    {
        // End:0x84
        if(name(IgnoreList[I].PlayerName) == name(PlayerName))
        {
            IgnoreList.Remove(I, 1);
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x1D;
    }
    //return;    
}

event bool WasPlayerIdIgnored(UniqueNetId UniqueId)
{
    local int I;
    local UniqueNetId ZeroId;

    // End:0x20
    if(UniqueId == ZeroId)
    {
        return false;
    }
    I = 0;
    J0x2B:
    // End:0x8E [Loop If]
    if(I < IgnoreList.Length)
    {
        // End:0x80
        if(IgnoreList[I].UniqueId == UniqueId)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x2B;
    }
    return false;
    //return ReturnValue;    
}

event bool WasPlayerNameIgnored(string PlayerName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7D [Loop If]
    if(I < IgnoreList.Length)
    {
        // End:0x6F
        if((PlayerName != "") && name(IgnoreList[I].PlayerName) == name(PlayerName))
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return false;
    //return ReturnValue;    
}

event array<FoxDataProvider_KeyBindings> GetKeyBindingProviders()
{
    local int I;
    local array<FoxDataProvider_KeyBindings> Providers;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < KeyBindingProviders.Length)
    {
        Providers.AddItem(FoxDataProvider_KeyBindings(KeyBindingProviders[I]));
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return Providers;
    //return ReturnValue;    
}

event array<FoxDataProvider_Controls> GetControlsProviders()
{
    local int I;
    local array<FoxDataProvider_Controls> Providers;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < ControlProviders.Length)
    {
        Providers.AddItem(FoxDataProvider_Controls(ControlProviders[I]));
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return Providers;
    //return ReturnValue;    
}

event array<FoxDataProvider_ControllerBindings> GetControllerBindingProviders()
{
    local int I;
    local array<FoxDataProvider_ControllerBindings> Providers;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < ControllerBindingProviders.Length)
    {
        Providers.AddItem(FoxDataProvider_ControllerBindings(ControllerBindingProviders[I]));
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return Providers;
    //return ReturnValue;    
}

event int GetNextMapIndex(class<FoxGame> GameClass)
{
    local array<FoxDataProvider_MapInfo> MapDataProviders, MapToChooseFrom;
    local int I, J, LeastPlayedMapTimeStamp;

    MapDataProviders = GetValidMapsForGameType(GameClass);
    I = 0;
    J0x28:
    // End:0xB2 [Loop If]
    if(I < MapDataProviders.Length)
    {
        // End:0xA4
        if(PlayedMaps.Find('MapName', MapDataProviders[I].MapName) < 0)
        {
            MapToChooseFrom.AddItem(MapDataProviders[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x28;
    }
    // End:0x25B
    if(MapToChooseFrom.Length == 0)
    {
        LeastPlayedMapTimeStamp = -1;
        I = 0;
        J0xDC:
        // End:0x25B [Loop If]
        if(I < PlayedMaps.Length)
        {
            J = 0;
            J0xFF:
            // End:0x24D [Loop If]
            if(J < MapDataProviders.Length)
            {
                // End:0x23F
                if(MapDataProviders[J].MapName ~= PlayedMaps[I].MapName)
                {
                    // End:0x1EB
                    if((LeastPlayedMapTimeStamp < 0) || PlayedMaps[I].LastUsed < LeastPlayedMapTimeStamp)
                    {
                        LeastPlayedMapTimeStamp = PlayedMaps[I].LastUsed;
                        MapToChooseFrom.Length = 0;
                    }
                    // End:0x23F
                    if(LeastPlayedMapTimeStamp == PlayedMaps[I].LastUsed)
                    {
                        MapToChooseFrom.AddItem(MapDataProviders[J]);
                    }
                }
                ++ J;
                // [Loop Continue]
                goto J0xFF;
            }
            ++ I;
            // [Loop Continue]
            goto J0xDC;
        }
    }
    return GetMapIndex(MapToChooseFrom[Rand(MapToChooseFrom.Length)].MapName);
    //return ReturnValue;    
}

event PlayMap(int MapIndex)
{
    local FoxDataProvider_MapInfo MapInfoProvider;
    local int I, LastPlayedMapTimeStamp;
    local string MapName;
    local int PlayedMapIndex;
    local PlayedMapInfo NewPlayedMapInfo;

    MapInfoProvider = GetMapDataProviderAtIndex(MapIndex);
    MapName = MapInfoProvider.MapName;
    // End:0x5E
    if(MapName == LastPlayedMapName)
    {
        return;
    }
    LastPlayedMapTimeStamp = 0;
    PlayedMapIndex = -1;
    I = 0;
    J0x83:
    // End:0x154 [Loop If]
    if(I < PlayedMaps.Length)
    {
        // End:0xFF
        if(PlayedMaps[I].LastUsed > LastPlayedMapTimeStamp)
        {
            LastPlayedMapTimeStamp = PlayedMaps[I].LastUsed;
        }
        // End:0x146
        if(PlayedMaps[I].MapName ~= MapName)
        {
            PlayedMapIndex = I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x83;
    }
    // End:0x199
    if(PlayedMapIndex >= 0)
    {
        PlayedMaps[PlayedMapIndex].LastUsed = LastPlayedMapTimeStamp + 1;
    }
    // End:0x1FE
    else
    {
        NewPlayedMapInfo.MapName = MapName;
        NewPlayedMapInfo.LastUsed = LastPlayedMapTimeStamp + 1;
        PlayedMaps.AddItem(NewPlayedMapInfo);
    }
    LastPlayedMapName = MapName;
    //return;    
}

function AddBannedPlayer(float CurrentTimeSeconds, float TimeToBan, UniqueNetId BannedID)
{
    local int I;
    local BannedPlayer NewBannedPlayer;

    I = 0;
    J0x0B:
    // End:0xCC [Loop If]
    if(I < BannedPlayers.Length)
    {
        // End:0xBE
        if(BannedPlayers[I].BannedID == BannedID)
        {
            BannedPlayers[I].BannedTimeStamp = CurrentTimeSeconds;
            BannedPlayers[I].TimeBanned = TimeToBan;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBannedPlayer.BannedID = BannedID;
    NewBannedPlayer.BannedTimeStamp = CurrentTimeSeconds;
    NewBannedPlayer.TimeBanned = TimeToBan;
    BannedPlayers.AddItem(NewBannedPlayer);
    //return;    
}

function bool IsPlayerBanned(UniqueNetId IDToCheck)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x6E [Loop If]
    if(I < BannedPlayers.Length)
    {
        // End:0x60
        if(BannedPlayers[I].BannedID == IDToCheck)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return false;
    //return ReturnValue;    
}

function UpdateBans(float CurrentTimeSeconds)
{
    local int I;

    I = BannedPlayers.Length - 1;
    J0x17:
    // End:0xA5 [Loop If]
    if(I >= 0)
    {
        // End:0x97
        if((CurrentTimeSeconds - BannedPlayers[I].BannedTimeStamp) >= BannedPlayers[I].TimeBanned)
        {
            BannedPlayers.Remove(I, 1);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function ClearBans()
{
    BannedPlayers.Length = 0;
    //return;    
}

function FoxSavedMigrationInfo CreateHostMigrationSettings()
{
    HostMigrationInfo = new (self) class'FoxSavedMigrationInfo';
    return HostMigrationInfo;
    //return ReturnValue;    
}

function ClearSavedHostMigrationSettings()
{
    HostMigrationInfo = none;
    //return;    
}

defaultproperties
{
    Tag=FoxMenuItems
}